[SETTING]

; MENCODER default parameter
PARAM_GENERAL = -noodml "$PATH_VIDEO$" -o "$PATH_OUT$" -mc 0

; ENCODING TEST PARAM ( encoding 60 seconds of file only )
PARAM_TEST = -endpos 60

; divx / xvid / x264 / MS-MPEG4(=Divx 3.1) / Motion JPEG / Lossless JPEG / WMV1(=WMV7) / WMV2(=WMV8)
PARAM_DIVX = -ovc lavc -lavcopts vcodec=mpeg4   -lavcopts vbitrate=$VID_BITRATE$  -ffourcc DIVX
PARAM_XVID = -ovc xvid -xvidencopts bitrate=$VID_BITRATE$ 
PARAM_DIV3 = -ovc lavc -lavcopts vcodec=msmpeg4 -lavcopts vbitrate=$VID_BITRATE$  -ffourcc DIV3
PARAM_MP43 = -ovc lavc -lavcopts vcodec=msmpeg4 -lavcopts vbitrate=$VID_BITRATE$  -ffourcc MP43
PARAM_WMV1 = -ovc lavc -lavcopts vcodec=wmv1    -lavcopts vbitrate=$VID_BITRATE$ 
PARAM_WMV2 = -ovc lavc -lavcopts vcodec=wmv2    -lavcopts vbitrate=$VID_BITRATE$ 
PARAM_X264 = -ovc x264 -x264encopts bitrate=$VID_BITRATE$ 
PARAM_MJPG = -ovc lavc -lavcopts vcodec=mjpeg   -lavcopts vbitrate=$VID_BITRATE$ 
PARAM_LJPG = -ovc lavc -lavcopts vcodec=ljpeg   -lavcopts vbitrate=$VID_BITRATE$ 


; INDEX REBUILD ONLY
PARAM_INDEXREBUILD = -noodml "$PATH_VIDEO$" -o "$PATH_OUT$" -ovc copy -oac copy 

; COPY ONLY
PARAM_VID_COPY = -ovc copy
PARAM_AUD_COPY = -oac copy

; SAMPLE RATE (optional)
PARAM_SRATE = -srate $AUD_SRATE$

; FPS (optional)
PARAM_FPS = -ofps $VID_FPS$ 

; VIDEO RESIZE OPTION (optional)
PARAM_RESIZE = -vf-add crop=$VID_CROP_W$:$VID_CROP_H$:-1:-1  -vf-add scale=$VID_SCALE_W$:$VID_SCALE_H$ -vf-add expand=$VID_W$:$VID_H$:-1:-1:1 

; LAME MP3 OPTION (optional?)
PARAM_LAME = -oac mp3lame -lameopts vbr=$AUD_VBR$  -lameopts br=$AUD_BITRATE$ -lameopts vol=$AUD_VOL$ -lameopts mode=$AUD_MODE$ -lameopts aq=$AUD_ALGORITHM$ -lameopts padding=3
PARAM_AC3  = -oac lavc    -lavcopts acodec=ac3:abitrate=$AUD_BITRATE$ -channels 2

; subtitle option (optional)
PARAM_SUB = -font "$PATH_FONT$" -sub "$PATH_SUB$" -utf8  -subpos $SUB_POS$ -subfont-text-scale $SUB_SIZE$ -subfont-blur $SUB_BLUR$ -subfont-outline $SUB_OUTLINE$

; volnorm
PARAM_VOLNORM = -af volnorm


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;                                    여기 부터는 주석                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


* mencoder 에 대한 자세한 설명은 man_page.html 파일 참조



* 변수 설명

$PATH_VIDEO$     : 비디오 원본 경로
$PATH_SUB$       : 자막 원본 경로 (utf8 이어야만 한다.)
$PATH_OUT$       : 출력 비디오 경로
$PATH_FONT$      : 폰트 경로
$VID_BITRATE$    : 비디오 비트레이트(kbps)
$VID_CROP_W$     : 원본이미지에서 잘라낼 폭
$VID_CROP_H$     :                       높이
$VID_FPS$        : 프레임(fps)
$VID_SCALE_W$    : 원본이미지에서 잘라낸 이미지를 리사이징할 크기
$VID_SCALE_H$    :
$VID_W$          : VID_SCALE_W 로 리사이징된 이미지를 확장할 크기 (주:위아래 검은 여백은 이때 생긴다.)
$VID_H$
$AUD_BITRATE$    : 오디오 비트레이트(bps)
$AUD_VOL$        : 오디오 볼륨 증폭(gain) (0~10)
$AUD_ALGORITHM$  : lame 오디오 인코딩 알고리즘 algorithmic quality (0-best/slowest, 9-worst/fastest)
$AUD_MODE$       : 오디오 모드 (생략시 자동) 0:stereo, 1:joint-stereo, 2:dualchannel, 3:mono
$AUD_VBR$        : 오디오 VBR 모드 0:cbr, 1:mt, 2:rh, 3:abr(권장), 4:mtrh
$AUD_SRATE$      : 오디오 비트레이트(Hz) 22100 44100 22050 




* 파라메터 풀어 쓰기

MENCODER_PARAM = 

// 기본 설정	
" -noodml "
// 경로 설정 
" \"$PATH_VIDEO$\" -o \"$PATH_OUT$\" -font \"$PATH_FONT$\" "
// 비디오 설정
" -ovc lavc "
" -lavcopts vcodec=mpeg4 -lavcopts vbitrate=$VID_BITRATE$ "
// 비디오 스페셜
" -vf-add crop=$VID_CROP_W$:$VID_CROP_H$:-1:-1  "
// 비디오 설정
" -ofps $VID_FPS$ "
" -vf-add scale=$VID_SCALE_W$:$VID_SCALE_H$ "
" -vf-add expand=$VID_W$:$VID_H$:-1:-1:1 "
// 오디오 설정 (lame)
" -oac mp3lame "
" -lameopts vbr=$AUD_VBR$ -lameopts br=$AUD_BITRATE$ -lameopts vol=$AUD_VOL$ -lameopts mode=$AUD_MODE$ -lameopts aq=$AUD_ALGORITHM$"


SUB_PARAM = 
// 자막 설정
" -utf8 -sub \"$PATH_SUB$\" -subpos $SUB_POS$ "
" -subfont-text-scale $SUB_SIZE$"	
" -subfont-blur $SUB_BLUR$ -subfont-outline $SUB_OUTLINE$ "


[힌트]
"-oac mp3lame" 대신 "-oac lavc" 를 쓰면 libavcodec 으로 mp3 인코딩이 가능하다. (차이점은 아직잘 모르겠다.)

